{
  This file was automatically generated on 2020-04-07.

  Delphi/Lazarus Bindings Version 2.1.27

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generators git on tinkerforge.com
}

unit BrickletRGBLEDButton;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter, Math, SyncObjs;

const
  BRICKLET_RGB_LED_BUTTON_DEVICE_IDENTIFIER = 282;
  BRICKLET_RGB_LED_BUTTON_DEVICE_DISPLAY_NAME = 'RGB LED Button Bricklet';

  BRICKLET_RGB_LED_BUTTON_FUNCTION_SET_COLOR = 1;
  BRICKLET_RGB_LED_BUTTON_FUNCTION_GET_COLOR = 2;
  BRICKLET_RGB_LED_BUTTON_FUNCTION_GET_BUTTON_STATE = 3;
  BRICKLET_RGB_LED_BUTTON_FUNCTION_SET_COLOR_CALIBRATION = 5;
  BRICKLET_RGB_LED_BUTTON_FUNCTION_GET_COLOR_CALIBRATION = 6;
  BRICKLET_RGB_LED_BUTTON_FUNCTION_GET_SPITFP_ERROR_COUNT = 234;
  BRICKLET_RGB_LED_BUTTON_FUNCTION_SET_BOOTLOADER_MODE = 235;
  BRICKLET_RGB_LED_BUTTON_FUNCTION_GET_BOOTLOADER_MODE = 236;
  BRICKLET_RGB_LED_BUTTON_FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237;
  BRICKLET_RGB_LED_BUTTON_FUNCTION_WRITE_FIRMWARE = 238;
  BRICKLET_RGB_LED_BUTTON_FUNCTION_SET_STATUS_LED_CONFIG = 239;
  BRICKLET_RGB_LED_BUTTON_FUNCTION_GET_STATUS_LED_CONFIG = 240;
  BRICKLET_RGB_LED_BUTTON_FUNCTION_GET_CHIP_TEMPERATURE = 242;
  BRICKLET_RGB_LED_BUTTON_FUNCTION_RESET = 243;
  BRICKLET_RGB_LED_BUTTON_FUNCTION_WRITE_UID = 248;
  BRICKLET_RGB_LED_BUTTON_FUNCTION_READ_UID = 249;
  BRICKLET_RGB_LED_BUTTON_FUNCTION_GET_IDENTITY = 255;

  BRICKLET_RGB_LED_BUTTON_CALLBACK_BUTTON_STATE_CHANGED = 4;

  BRICKLET_RGB_LED_BUTTON_BUTTON_STATE_PRESSED = 0;
  BRICKLET_RGB_LED_BUTTON_BUTTON_STATE_RELEASED = 1;
  BRICKLET_RGB_LED_BUTTON_BOOTLOADER_MODE_BOOTLOADER = 0;
  BRICKLET_RGB_LED_BUTTON_BOOTLOADER_MODE_FIRMWARE = 1;
  BRICKLET_RGB_LED_BUTTON_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
  BRICKLET_RGB_LED_BUTTON_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
  BRICKLET_RGB_LED_BUTTON_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
  BRICKLET_RGB_LED_BUTTON_BOOTLOADER_STATUS_OK = 0;
  BRICKLET_RGB_LED_BUTTON_BOOTLOADER_STATUS_INVALID_MODE = 1;
  BRICKLET_RGB_LED_BUTTON_BOOTLOADER_STATUS_NO_CHANGE = 2;
  BRICKLET_RGB_LED_BUTTON_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
  BRICKLET_RGB_LED_BUTTON_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
  BRICKLET_RGB_LED_BUTTON_BOOTLOADER_STATUS_CRC_MISMATCH = 5;
  BRICKLET_RGB_LED_BUTTON_STATUS_LED_CONFIG_OFF = 0;
  BRICKLET_RGB_LED_BUTTON_STATUS_LED_CONFIG_ON = 1;
  BRICKLET_RGB_LED_BUTTON_STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_RGB_LED_BUTTON_STATUS_LED_CONFIG_SHOW_STATUS = 3;

type
  TArray0To2OfUInt8 = array [0..2] of byte;
  TArray0To63OfUInt8 = array [0..63] of byte;

  TBrickletRGBLEDButton = class;
  TBrickletRGBLEDButtonNotifyButtonStateChanged = procedure(sender: TBrickletRGBLEDButton; const state: byte) of object;

  /// <summary>
  ///  Push button with built-in RGB LED
  /// </summary>
  TBrickletRGBLEDButton = class(TDevice)
  private
    buttonStateChangedCallback: TBrickletRGBLEDButtonNotifyButtonStateChanged;
  protected
    procedure CallbackWrapperButtonStateChanged(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid: string; ipcon_: TIPConnection);

    /// <summary>
    ///  Sets the color of the LED.
    /// </summary>
    procedure SetColor(const red: byte; const green: byte; const blue: byte); virtual;

    /// <summary>
    ///  Returns the LED color as set by <see cref="BrickletRGBLEDButton.TBrickletRGBLEDButton.SetColor"/>.
    /// </summary>
    procedure GetColor(out red: byte; out green: byte; out blue: byte); virtual;

    /// <summary>
    ///  Returns the current state of the button (either pressed or released).
    /// </summary>
    function GetButtonState: byte; virtual;

    /// <summary>
    ///  Sets a color calibration. Some colors appear brighter then others,
    ///  so a calibration may be necessary for uniform colors.
    ///  
    ///  The calibration is saved in flash. You don't need to call this
    ///  function on every startup.
    /// </summary>
    procedure SetColorCalibration(const red: byte; const green: byte; const blue: byte); virtual;

    /// <summary>
    ///  Returns the color calibration as set by <see cref="BrickletRGBLEDButton.TBrickletRGBLEDButton.SetColorCalibration"/>.
    /// </summary>
    procedure GetColorCalibration(out red: byte; out green: byte; out blue: byte); virtual;

    /// <summary>
    ///  Returns the error count for the communication between Brick and Bricklet.
    ///  
    ///  The errors are divided into
    ///  
    ///  * ACK checksum errors,
    ///  * message checksum errors,
    ///  * framing errors and
    ///  * overflow errors.
    ///  
    ///  The errors counts are for errors that occur on the Bricklet side. All
    ///  Bricks have a similar function that returns the errors on the Brick side.
    /// </summary>
    procedure GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword); virtual;

    /// <summary>
    ///  Sets the bootloader mode and returns the status after the requested
    ///  mode change was instigated.
    ///  
    ///  You can change from bootloader mode to firmware mode and vice versa. A change
    ///  from bootloader mode to firmware mode will only take place if the entry function,
    ///  device identifier and CRC are present and correct.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function SetBootloaderMode(const mode: byte): byte; virtual;

    /// <summary>
    ///  Returns the current bootloader mode, see <see cref="BrickletRGBLEDButton.TBrickletRGBLEDButton.SetBootloaderMode"/>.
    /// </summary>
    function GetBootloaderMode: byte; virtual;

    /// <summary>
    ///  Sets the firmware pointer for <see cref="BrickletRGBLEDButton.TBrickletRGBLEDButton.WriteFirmware"/>. The pointer has
    ///  to be increased by chunks of size 64. The data is written to flash
    ///  every 4 chunks (which equals to one page of size 256).
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    procedure SetWriteFirmwarePointer(const pointer: longword); virtual;

    /// <summary>
    ///  Writes 64 Bytes of firmware at the position as written by
    ///  <see cref="BrickletRGBLEDButton.TBrickletRGBLEDButton.SetWriteFirmwarePointer"/> before. The firmware is written
    ///  to flash every 4 chunks.
    ///  
    ///  You can only write firmware in bootloader mode.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function WriteFirmware(const data: array of byte): byte; virtual;

    /// <summary>
    ///  Sets the status LED configuration. By default the LED shows
    ///  communication traffic between Brick and Bricklet, it flickers once
    ///  for every 10 received data packets.
    ///  
    ///  You can also turn the LED permanently on/off or show a heartbeat.
    ///  
    ///  If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    /// </summary>
    procedure SetStatusLEDConfig(const config: byte); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletRGBLEDButton.TBrickletRGBLEDButton.SetStatusLEDConfig"/>
    /// </summary>
    function GetStatusLEDConfig: byte; virtual;

    /// <summary>
    ///  Returns the temperature as measured inside the microcontroller. The
    ///  value returned is not the ambient temperature!
    ///  
    ///  The temperature is only proportional to the real temperature and it has bad
    ///  accuracy. Practically it is only useful as an indicator for
    ///  temperature changes.
    /// </summary>
    function GetChipTemperature: smallint; virtual;

    /// <summary>
    ///  Calling this function will reset the Bricklet. All configurations
    ///  will be lost.
    ///  
    ///  After a reset you have to create new device objects,
    ///  calling functions on the existing ones will result in
    ///  undefined behavior!
    /// </summary>
    procedure Reset; virtual;

    /// <summary>
    ///  Writes a new UID into flash. If you want to set a new UID
    ///  you have to decode the Base58 encoded UID string into an
    ///  integer first.
    ///  
    ///  We recommend that you use Brick Viewer to change the UID.
    /// </summary>
    procedure WriteUID(const uid: longword); virtual;

    /// <summary>
    ///  Returns the current UID as an integer. Encode as
    ///  Base58 to get the usual string version.
    /// </summary>
    function ReadUID: longword; virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to,
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    ///  The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
    ///  connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
    ///  position 'z'.
    ///  
    ///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  |device_identifier_constant|
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word); override;

    /// <summary>
    ///  This callback is triggered every time the button state changes from pressed to
    ///  released or from released to pressed.
    ///  
    ///  The parameter is the current state of the button.
    /// </summary>
    property OnButtonStateChanged: TBrickletRGBLEDButtonNotifyButtonStateChanged read buttonStateChangedCallback write buttonStateChangedCallback;
  end;

implementation

constructor TBrickletRGBLEDButton.Create(const uid: string; ipcon_: TIPConnection);
begin
  inherited Create(uid, ipcon_, BRICKLET_RGB_LED_BUTTON_DEVICE_IDENTIFIER, BRICKLET_RGB_LED_BUTTON_DEVICE_DISPLAY_NAME);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 0;

  responseExpected[BRICKLET_RGB_LED_BUTTON_FUNCTION_SET_COLOR] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_RGB_LED_BUTTON_FUNCTION_GET_COLOR] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RGB_LED_BUTTON_FUNCTION_GET_BUTTON_STATE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RGB_LED_BUTTON_FUNCTION_SET_COLOR_CALIBRATION] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_RGB_LED_BUTTON_FUNCTION_GET_COLOR_CALIBRATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RGB_LED_BUTTON_FUNCTION_GET_SPITFP_ERROR_COUNT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RGB_LED_BUTTON_FUNCTION_SET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RGB_LED_BUTTON_FUNCTION_GET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RGB_LED_BUTTON_FUNCTION_SET_WRITE_FIRMWARE_POINTER] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_RGB_LED_BUTTON_FUNCTION_WRITE_FIRMWARE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RGB_LED_BUTTON_FUNCTION_SET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_RGB_LED_BUTTON_FUNCTION_GET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RGB_LED_BUTTON_FUNCTION_GET_CHIP_TEMPERATURE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RGB_LED_BUTTON_FUNCTION_RESET] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_RGB_LED_BUTTON_FUNCTION_WRITE_UID] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_RGB_LED_BUTTON_FUNCTION_READ_UID] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RGB_LED_BUTTON_FUNCTION_GET_IDENTITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

  callbackWrappers[BRICKLET_RGB_LED_BUTTON_CALLBACK_BUTTON_STATE_CHANGED] := {$ifdef FPC}@{$endif}CallbackWrapperButtonStateChanged;

  (ipcon as TIPConnection).AddDevice(self);
end;

procedure TBrickletRGBLEDButton.SetColor(const red: byte; const green: byte; const blue: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_BUTTON_FUNCTION_SET_COLOR, 11);
  LEConvertUInt8To(red, 8, request);
  LEConvertUInt8To(green, 9, request);
  LEConvertUInt8To(blue, 10, request);
  SendRequest(request, 0);
end;

procedure TBrickletRGBLEDButton.GetColor(out red: byte; out green: byte; out blue: byte);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_BUTTON_FUNCTION_GET_COLOR, 8);
  response := SendRequest(request, 11);
  red := LEConvertUInt8From(8, response);
  green := LEConvertUInt8From(9, response);
  blue := LEConvertUInt8From(10, response);
end;

function TBrickletRGBLEDButton.GetButtonState: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_BUTTON_FUNCTION_GET_BUTTON_STATE, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletRGBLEDButton.SetColorCalibration(const red: byte; const green: byte; const blue: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_BUTTON_FUNCTION_SET_COLOR_CALIBRATION, 11);
  LEConvertUInt8To(red, 8, request);
  LEConvertUInt8To(green, 9, request);
  LEConvertUInt8To(blue, 10, request);
  SendRequest(request, 0);
end;

procedure TBrickletRGBLEDButton.GetColorCalibration(out red: byte; out green: byte; out blue: byte);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_BUTTON_FUNCTION_GET_COLOR_CALIBRATION, 8);
  response := SendRequest(request, 11);
  red := LEConvertUInt8From(8, response);
  green := LEConvertUInt8From(9, response);
  blue := LEConvertUInt8From(10, response);
end;

procedure TBrickletRGBLEDButton.GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_BUTTON_FUNCTION_GET_SPITFP_ERROR_COUNT, 8);
  response := SendRequest(request, 24);
  errorCountAckChecksum := LEConvertUInt32From(8, response);
  errorCountMessageChecksum := LEConvertUInt32From(12, response);
  errorCountFrame := LEConvertUInt32From(16, response);
  errorCountOverflow := LEConvertUInt32From(20, response);
end;

function TBrickletRGBLEDButton.SetBootloaderMode(const mode: byte): byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_BUTTON_FUNCTION_SET_BOOTLOADER_MODE, 9);
  LEConvertUInt8To(mode, 8, request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletRGBLEDButton.GetBootloaderMode: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_BUTTON_FUNCTION_GET_BOOTLOADER_MODE, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletRGBLEDButton.SetWriteFirmwarePointer(const pointer: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_BUTTON_FUNCTION_SET_WRITE_FIRMWARE_POINTER, 12);
  LEConvertUInt32To(pointer, 8, request);
  SendRequest(request, 0);
end;

function TBrickletRGBLEDButton.WriteFirmware(const data: array of byte): byte;
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_BUTTON_FUNCTION_WRITE_FIRMWARE, 72);
  if (Length(data) <> 64) then raise EInvalidParameterException.Create('Data has to be exactly 64 items long');
  for i := 0 to Length(data) - 1 do LEConvertUInt8To(data[i], 8 + (i * 1), request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletRGBLEDButton.SetStatusLEDConfig(const config: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_BUTTON_FUNCTION_SET_STATUS_LED_CONFIG, 9);
  LEConvertUInt8To(config, 8, request);
  SendRequest(request, 0);
end;

function TBrickletRGBLEDButton.GetStatusLEDConfig: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_BUTTON_FUNCTION_GET_STATUS_LED_CONFIG, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletRGBLEDButton.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_BUTTON_FUNCTION_GET_CHIP_TEMPERATURE, 8);
  response := SendRequest(request, 10);
  result := LEConvertInt16From(8, response);
end;

procedure TBrickletRGBLEDButton.Reset;
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_BUTTON_FUNCTION_RESET, 8);
  SendRequest(request, 0);
end;

procedure TBrickletRGBLEDButton.WriteUID(const uid: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_BUTTON_FUNCTION_WRITE_UID, 12);
  LEConvertUInt32To(uid, 8, request);
  SendRequest(request, 0);
end;

function TBrickletRGBLEDButton.ReadUID: longword;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_BUTTON_FUNCTION_READ_UID, 8);
  response := SendRequest(request, 12);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletRGBLEDButton.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_BUTTON_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request, 33);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

procedure TBrickletRGBLEDButton.CallbackWrapperButtonStateChanged(const packet: TByteArray);
var state: byte;
begin
  if (Length(packet) <> 9) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  state := LEConvertUInt8From(8, packet);
  if (Assigned(buttonStateChangedCallback)) then begin
    buttonStateChangedCallback(self, state);
  end;
end;

end.
